// SepConDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SepCon.h"
#include "SepConDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSepConDlg dialog

CSepConDlg::CSepConDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSepConDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSepConDlg)
	m_Status = _T("");
	m_Dir = _T("");
	m_Adir = _T("");
	m_Prompt = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSepConDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSepConDlg)
	DDX_Control(pDX, IDC_SETSIZE, m_setsize);
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDCANCEL, m_exit);
	DDX_Control(pDX, IDC_PROCESS, m_process);
	DDX_Control(pDX, IDC_AIM, m_Aim);
	DDX_Control(pDX, IDC_DEL, m_del);
	DDX_Control(pDX, IDC_UP, m_up);
	DDX_Control(pDX, IDC_DOWN, m_down);
	DDX_Control(pDX, IDC_SOURCE, m_Source);
	DDX_Control(pDX, IDC_BUTTON2, m_apart);
	DDX_Control(pDX, IDC_FOPEN, m_open);
	DDX_Text(pDX, IDC_STATUS, m_Status);
	DDX_Text(pDX, IDC_DIR, m_Dir);
	DDX_Text(pDX, IDC_ADIR, m_Adir);
	DDX_Text(pDX, IDC_PROMPT, m_Prompt);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSepConDlg, CDialog)
	//{{AFX_MSG_MAP(CSepConDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FOPEN, OnConect)
	ON_BN_CLICKED(IDC_UP, OnUp)
	ON_BN_CLICKED(IDC_DOWN, OnDown)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_BN_CLICKED(IDC_PROCESS, OnProcess)
	ON_BN_CLICKED(IDC_BUTTON2, OnPart)
	ON_BN_CLICKED(IDC_SETSIZE, OnSetsize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSepConDlg message handlers

BOOL CSepConDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_bopen.LoadBitmap(IDB_OPEN);
	m_bapart.LoadBitmap(IDB_APART);
	m_bup.LoadBitmap(IDB_UP);
	m_bdown.LoadBitmap(IDB_DOWN);
	m_bdel.LoadBitmap(IDB_DEL);
	m_bprocess.LoadBitmap(IDB_PROCESS);
	m_bexit.LoadBitmap(IDB_EXIT);
	m_bsetsize.LoadBitmap(IDB_SETSIZE);
	
	m_apart.SetBitmap(m_bapart);
	m_open.SetBitmap(m_bopen);
	m_up.SetBitmap(m_bup);
	m_down.SetBitmap(m_bdown);
	m_del.SetBitmap(m_bdel);
	m_process.SetBitmap(m_bprocess);
	m_exit.SetBitmap(m_bexit);
	m_setsize.SetBitmap(m_bsetsize);
	
	m_size=1500000l;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSepConDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSepConDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSepConDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSepConDlg::OnConect() 
{
	// TODO: Add your control notification handler code here
	CFileDialog m_file(TRUE,NULL,"deafault",NULL,NULL,NULL);

	m_file.m_ofn.Flags|=OFN_ALLOWMULTISELECT;
	m_file.m_ofn.lpstrFile=filebuff=new char[60000l];
	m_file.m_ofn.lpstrFile[0]=NULL;
	m_file.m_ofn.nMaxFile=60000l;
	
	m_file.DoModal();

	m_Source.ResetContent();
	
	int i=0;
	while(i!=-1){
		i++;
		m_Source.InsertString(-1,GetmStr(m_file.m_ofn.lpstrFile,i));
		//m_file.m_ofn.lpstrTitle
	}
	m_Source.DeleteString(m_Source.GetCount()-1);
	m_Dir=filebuff;

	if(m_Source.GetCount()<1){
		m_Source.InsertString(-1,filebuff);
	}
	m_Status="CONNECTING...";
	
	UpdateData(FALSE);
	m_state=TRUE;
}


LPSTR CSepConDlg::GetmStr(LPSTR buff, INT & i)
{
	long n=0;

	for(int j=0;j<i && i!=-1;j++){
		while(buff[n]!=NULL)n++;n++;
		if(buff[n]==NULL){
			i=-1;
		}
	}

	if(i==-1 && j==1){
		while(buff[n]!='\\' && n>0)n--;
		n++;
	}
	return((LPSTR)&buff[n]);
}

void CSepConDlg::OnUp() 
{
	// TODO: Add your control notification handler code here
	int i=m_Source.GetCurSel(); 
	if(i>0 && m_state==TRUE){
		LPSTR buff=new char[100];
		m_Source.GetText(i,buff);
		m_Source.DeleteString(i);
		m_Source.InsertString(i-1,buff);
		delete buff;
	}
	m_Source.SetCurSel(i-1); 
}

void CSepConDlg::OnDown() 
{
	// TODO: Add your control notification handler code here
	int i=m_Source.GetCurSel(); 
	if(i<(m_Source.GetCount()-1) && m_state==TRUE){
		LPSTR buff=new char[100];
		m_Source.GetText(i,buff);
		m_Source.DeleteString(i);
		m_Source.InsertString(i+1,buff);
		delete buff;

	}	
	m_Source.SetCurSel(i+1); 
	//CListBox
}

void CSepConDlg::OnDel() 
{
	// TODO: Add your control notification handler code here
	int i=m_Source.GetCurSel(); 
	if(m_state==TRUE)m_Source.DeleteString(i);
	
}


void CSepConDlg::OnProcess() 
{
	// TODO: Add your control notification handler code here
	if(m_state==TRUE){

	m_Aim.ResetContent();
	CString m_str;

	CFileDialog dest(FALSE,NULL,"default",NULL,NULL,NULL);

	m_str=filebuff;
	m_str+="\\default.pac";
	if(dest.DoModal()==IDOK)m_str=dest.m_ofn.lpstrFile;
	//m_Adir=m_str;
	m_Aim.InsertString(-1,m_str);
	UpdateData(FALSE);

	FILE *source,*target;

	target=fopen(dest.m_ofn.lpstrFile,"wb");
	fseek(target,0l,SEEK_SET);
	
	long len=0;
	long olen;
	LPSTR spath=new char[100];

	for(int i=0;i<m_Source.GetCount();i++){
		len=0;
		m_Source.GetText(i,spath);
		m_str=m_Dir+"\\";
		m_str+=spath;
		if((source=fopen(m_str,"rb"))==NULL){
			MessageBox("File not found.",NULL,MB_ICONWARNING);
		}
		m_Prompt=m_str;
	
		fseek(source,0l,SEEK_END);
		olen=len=ftell(source);
		fseek(source,0l,SEEK_SET);
		UpdateData(FALSE);
		
		char* buff=new char[64000l];

		while(len>64000l){
			fread(buff,1,64000l,source);
			fwrite(buff,1,64000l,target);
			len-=64000l;
			m_Progress.SetPos(((olen-len)*100/olen));
		}

		fread(buff,len,1,source);
		fwrite((char*)&buff[0],len,1,target);
		m_Progress.SetPos(100);

		delete buff;
		fclose(source);
	}

	fclose(target);
	delete spath;
	m_Prompt="";
	UpdateData(FALSE);
	}


	else if(m_state==FALSE){
		FILE *source,*target;

		m_Aim.ResetContent();
		m_Source.ResetContent();
		source=fopen(m_Dir,"rb");
		fseek(source,0l,SEEK_END);
		
		long len=ftell(source);
		long olen=len;
		fseek(source,0l,SEEK_SET);
		
		m_Adir=m_Dir;
		UpdateData(FALSE);
		CString m_str;
		char m_istr[3];
		LPSTR buff=new char[60000l];
		long m_isize=0;
		int i=0;
		m_istr[2]=NULL;

		while(len>m_size){

			m_str=m_Adir;
			m_str+=".p";
			m_istr[0]='0'+i/10;
			m_istr[1]='0'+i%10;
			m_str+=m_istr;

			m_Aim.InsertString(-1,m_str);
			target=fopen(m_str,"wb");
			m_isize=m_size;

		while(m_isize>60000l){
				fread(buff,1,60000l,source);
				fwrite(buff,1,60000l,target);
				m_Progress.SetPos((olen-len-m_isize)*100/olen);
				m_isize-=60000l;
			}
			fread(buff,1,m_isize,source);
			fwrite(buff,1,m_isize,target);
			
			fclose(target);
			m_Progress.SetPos((olen-len-m_isize)*100/olen);
			len-=m_size;
			i++;
		}

		m_str=m_Adir;
		m_str+=".p";
		m_istr[0]='0'+i/10;
		m_istr[1]='0'+i%10;
		m_str+=m_istr;

		m_Aim.InsertString(-1,m_str);
		target=fopen(m_str,"wb");
		m_isize=len;
		while(m_isize>60000l){
			fread(buff,1,60000l,source);
			fwrite(buff,1,60000l,target);
			m_Progress.SetPos((olen-len-m_isize)*100/olen);
			m_isize-=60000l;
		}
		fread(buff,1,m_isize,source);
		fwrite(buff,1,m_isize,target);
		m_Progress.SetPos(100);
		fclose(target);


		delete buff;
		fclose(source);
	}
}

void CSepConDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	//delete filebuff;	
	CDialog::OnOK();
	CDialog::OnCancel();
}

void CSepConDlg::OnPart() 
{
	// TODO: Add your control notification handler code here
	m_state=FALSE;
	m_Status="PARTING...";

	CFileDialog m_file(TRUE,NULL,NULL,NULL,NULL);
	m_file.DoModal();
	m_Dir=m_file.m_ofn.lpstrFile;
	m_Source.InsertString(-1,m_file.m_ofn.lpstrFile);
	UpdateData(FALSE);
}

void CSepConDlg::OnSetsize() 
{
	// TODO: Add your control notification handler code here
	CSetsize m_setsize;
	
	if(m_setsize.DoModal()==IDOK && m_state==FALSE){
		m_Adir=m_setsize.m_File;
		m_size=m_setsize.m_size;
		UpdateData(FALSE);
		if(m_setsize.m_KB==TRUE)m_size*=1024;
	}
}
